﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using HLWebOKBAdminPlugin.OKBAdministrationService;
using HLWebOKBAdminPlugin.Helpers;

namespace HLWebOKBAdminPlugin.Models {
    public class AdminModel {
        //member var
        private IList<AlgorithmClass> algorithmClassList;

        public String SelectedSubMenu { get; set; }
        public IList<AlgorithmClass> AlgorithmClassProp { get { return algorithmClassList; } set { ;} }

        //get all algorithm classes
        public IList<AlgorithmClass> AlgorithmClassGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            algorithmClassList = new List<AlgorithmClass>();

            if (adminClient != null) {
                AlgorithmClass[] algorithmClasses = adminClient.GetAlgorithmClasses();
                foreach (AlgorithmClass ac in algorithmClasses) {
                    algorithmClassList.Add(ac);

                }
            }//if (adminClient != null)

            return algorithmClassList;
        }//AlgorithmClassGetAll
        
        //get all algorithms
        public IList<Algorithm> AlgorithmsGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            IList<Algorithm> algorithmList = new List<Algorithm>();

            if (adminClient != null) {
                Algorithm[] algorithm = adminClient.GetAlgorithms();
                foreach (Algorithm al in algorithm) {
                    algorithmList.Add(al);

                }
            }//if (adminClient != null)

            return algorithmList;
        }//AlgorithmsGetAll

        public IList<ProblemClass> ProblemClassGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            IList<ProblemClass> problemClassList = new List<ProblemClass>();

            if (adminClient != null) {
                ProblemClass[] problemClasses = adminClient.GetProblemClasses();
                foreach (ProblemClass pc in problemClasses) {
                    problemClassList.Add(pc);
                }
            }//if (adminClient != null)

            return problemClassList;
        }//ProblemClassGetAll

        public IList<Problem> ProblemsGetAll() {
            AdministrationServiceClient adminClient = Admin.GetClientFactory();

            IList<Problem> problemList = new List<Problem>();

            if (adminClient != null) {
                Problem[] problem = adminClient.GetProblems();
                foreach (Problem pr in problem) {
                    problemList.Add(pr);

                }
            }//if (adminClient != null)

            return problemList;
        }//ProblemsGetAll
    }
}