﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Reflection;

namespace HLWebOKBQueryPlugin.Views.Query {
    public partial class RunCollectionDetail : System.Web.UI.UserControl {
        private object currentObject = null;
        public object detailObject {
            get { return currentObject; }
            set {
                currentObject = value;
                FillDetails();
            }
        }

        protected void Page_Load(object sender, EventArgs e) {
            currentObject = getTest();

            FillDetails();
        }

        protected void FillDetails() {
            if (currentObject != null) {
                Type rcd = currentObject.GetType();

                foreach (PropertyInfo pi in rcd.GetProperties()) {
                    TableRow tr = new TableRow();
                    TableCell tc = new TableCell();
                    tc.Text = pi.Name;
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    try {
                        tc.Text = pi.GetValue(currentObject, null).ToString();
                    } catch (Exception ex) {
                        tc.Text = ex.Message;
                    }
                    tr.Cells.Add(tc);
                    TableRunDetail.Rows.Add(tr);
                }
            }
        }

        private RunCollectionData getTest() {
            OKBQueryService.Run testrun = new OKBQueryService.Run();

            testrun.Id = 34;
            testrun.Algorithm = new OKBQueryService.Algorithm();
            testrun.Algorithm.Name = "TestAlgo";
            testrun.Algorithm.AlgorithmClass = "TestAlgoClass";

            RunCollectionData run = new RunCollectionData(testrun);
            
            return run;
        }
    }
}